routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::get('login/google', 'Auth\LoginController@redirectToProvider');
Route::get('login/google/callback', 'Auth\LoginController@handleProviderCallback');

Route::get('/', 'GuestController@index')->name('guest');

Auth::routes(['verify' => true]);

Route::group(['prefix' => 'internal', 'middleware' => ['role:admin|manager|staff']], function() {
    Route::get('/home', 'InternalController@index')->name('home');
    Route::resource('order', 'OrderController');
});

Route::group(['prefix' => 'internal', 'middleware' => ['role:admin|manager']], function() {
    Route::resource('hotel', 'HotelController');
    Route::resource('log', 'ActivityLogController');
    Route::resource('staff', 'StaffController');

});

Route::group(['prefix' => 'admin', 'middleware' => ['role:admin']], function() {
    Route::get('user', 'UserController@userIndex')->name('user.index');
    Route::get('user/{id}/view', 'UserController@userView')->name('user.view');
    Route::get('user/{id}/edit', 'UserController@userEdit')->name('user.edit');
    Route::patch('user/update', 'UserController@userUpdate')->name('user.update');
    Route::get('user/create', 'UserController@userCreate')->name('user.create');
    Route::post('user/store', 'UserController@store')->name('user.store');
    Route::delete('user/{id}/delete', 'UserController@destroy')->name('user.destroy');

});

Route::group(['prefix' => 'member', 'middleware' => ['verified','role:member']], function() {
    Route::get('/home', 'MemberController@index')->name('member.home');
    Route::patch('user/update', 'UserController@userUpdate')->name('member.user.update');
    Route::resource('booking', 'OrderController');
    // Route::get('/manage', ['middleware' => ['permission:manage-admins'], 'uses' => 'AdminController@manageAdmins']);
});



Route::get('/profile/edit', 'UserController@userEdit')->name('profile.edit');
Route::get('/profile/view', 'UserController@userView')->name('profile.view');

app/Hotel.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Wildside\Userstamps\Userstamps;
use Spatie\Activitylog\Traits\LogsActivity;
use Illuminate\Database\Eloquent\SoftDeletes;


class Hotel extends Model
{
    use Userstamps;
    use LogsActivity;
    use SoftDeletes;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'code', 'name', 'address', 'phone'
    ];

    protected static $logFillable = true;

    public function rooms()
    {
        return $this->hasMany('App\Room');
    }
    public function staffs()
    {
        return $this->hasMany('App\Staff');
    }
    public function manager()
    {
        return $this->belongsTo('App\User', 'manager_id', 'id');
    }
}

app/Http/Controllers/HotelController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Hotel;
use App\Staff;
use App\User;
use Auth;


class HotelController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $user = Auth::user();

        if ( $user->hasRole('admin') )
           $hotels = Hotel::all();
        if ( $user->hasRole('manager') )
           $hotels = Hotel::where('manager_id',$user->id)->get();
        if ( $user->hasRole('staff') )
           $hotels = Staff::with('hotels')
                        ->where('user_id',$user->id)
                        ->get();

        return view('internal.hotel.index', compact('hotels'));

    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function apiIndex()
    {
        $user = auth('api')->user();

        if ( $user->hasRole('admin') )
           $hotels = Hotel::all();
        if ( $user->hasRole('manager') )
           $hotels = Hotel::where('manager_id',$user->id)->get();
        if ( $user->hasRole('staff') )
           $hotels = Staff::with('hotels')
                        ->where('user_id',$user->id)
                        ->get();

        return response()->json([
            'data' => $hotels
        ]);

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $managers = User::whereRoleIs('manager')->get();

        return view('internal.hotel.create', compact('managers'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // dd($request);
        //get 1st char on each word
        $words = explode(" ", $request->name);
        $acronym = "";
        foreach ($words as $w)
            $acronym .= $w[0];

        $hotel = new Hotel;
        $hotel->code = $acronym;
        $hotel->name = $request->name;
        $hotel->manager_id = $request->manager_id;
        $hotel->phone = $request->phone;
        $hotel->address = $request->address;

        if($request->photo) {
            $file = $request->file('photo');
            $path = $file->store('images','s3','public');
            $hotel->image_url = $path;
        }

        $hotel->save();

        return redirect()->route('hotel.index')->withFlashSuccess('Hotel Saved.');


    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $user = Auth::user();
        $managers = User::whereRoleIs('manager')->get();
        $hotel = Hotel::findOrFail($id);

        if ( $user->hasRole('manager') )
            if( $hotel->manager_id !== $user->id)
                return abort(403,'Hotel not managed by you');

        if ( $user->hasRole('staff') )
            return abort(403,'You Are Not Assigned to this Hotel');
        //    $hotels = Staff::where('user_id',$user->id)
        //                 ->get('hotel_id')->toArray();
        //     if( inArray( $hotels, $user->id ) == FALSE )



        return view('internal.hotel.view', compact('hotel','managers'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $user = Auth::user();
        $managers = User::whereRoleIs('manager')->get();
        $hotel = Hotel::findOrFail($id);

        if ( $user->hasRole('manager') )
            if( $hotel->manager_id !== $user->id)
                return abort(403,'Hotel not managed by you');

        if ( $user->hasRole('staff') )
            return abort(403,'You Are Not Assigned to this Hotel');
        //    $hotels = Staff::where('user_id',$user->id)
        //                 ->get('hotel_id')->toArray();
        //     if( inArray( $hotels, $user->id ) == FALSE )



        return view('internal.hotel.edit', compact('hotel','managers'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id = null)
    {
        $hotel = Hotel::findOrFail($id);
        
        $hotel->name = $request->name;
        $hotel->phone = $request->phone;
        $hotel->address = $request->address;

        if(isset($request->manager_id))
            $hotel->manager_id = $request->manager_id;

        if($request->photo) {
            $file = $request->file('photo');
            $path = $file->store('images','s3','public');
            $hotel->image_url = $path;
        }

        $hotel->save();

        return redirect()->route('hotel.index')->withFlashSuccess('Hotel Updated.');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $hotel = Hotel::findOrFail($id)->delete();
        if($hotel)
            return response()->json(['message' => 'success'], 200);
        else
            return response()->json(['message' => 'Hotel is being used'], 400);

    }
}

app/Http/Controllers/InternalController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Hotel;
use Auth;

class InternalController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $hotels = Hotel::where('manager_id', Auth::user()->id )->get();

        return view('internal.home',compact('hotels'));
    }
}

resources/views/internal/hotel/create.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">

{{ html()->Form('POST', route('hotel.store'))->class('form-horizontal')->acceptsFiles()->open() }}
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Add Hotel</h6>
    </div>
    <div class="card-body">
        <div class="row mt-4 mb-4">
          <div class="col">
            <div class="form-group row">
              {{ html()->label('Hotel Name')->class('col-md-2 form-control-label')->for('name') }}
                <div class="col-md-10">
                    {{ html()->text('name')
                        ->class('form-control')
                        ->placeholder('Please Add Hotel Name')
                        ->attribute('maxlength', 191)

                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            @role('admin')
            <div class="form-group row">
              {{ html()->label('Manager')->class('col-md-2 form-control-label')->for('manager') }}
                <div class="col-md-10">
                    {{ html()->select('manager_id', $managers->pluck('name','id'))
                        ->class('form-control')

                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            @endrole
            <div class="form-group row">
              {{ html()->label('Address')->class('col-md-2 form-control-label')->for('address') }}
                  <div class="col-md-10">
                      {{ html()->text('address')
                          ->class('form-control')
                          ->placeholder('Address')
                          ->attribute('maxlength', 191)

                          ->required() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Phone')->class('col-md-2 form-control-label')->for('phone') }}

                  <div class="col-md-10">
                      {{ html()->text('phone')
                          ->class('form-control')
                          ->placeholder('Hotel Phone')
                          ->attribute('maxlength', 191)

                          ->required() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('About')->class('col-md-2 form-control-label')->for('about') }}

                  <div class="col-md-10">
                      {{ html()->textarea('about')
                          ->class('form-control')
                          ->placeholder('Hotel Quick Review')
                          ->attribute('maxlength', 191)

                          ->required() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="row">

            </div>
            <div class="form-group row">
                {{ html()->label('Photo')->class('col-md-2 form-control-label')->for('photo') }}

                    <div class="col-md-10">

                        {{ html()->file('photo')
                            ->class('form-control') }}
                    </div><!--col-->
              </div><!--form-group-->

          </div>
        </div>

    </div>
    <div class="card-footer">
      <div class="row">
          <div class="col">
              <a href="{{ route('hotel.index') }}" class="btn btn-danger btn-sm">Cancel</a>
          </div><!--col-->

          <div class="col text-right">
            <button type="submit" class="btn btn-sm btn-success"><i class="fa fa-save"></i> Update</button>
              {{-- {{ form_submit('Update') }} --}}
          </div><!--row-->
      </div><!--row-->
    </div><!--card-footer-->
  </div>
  {{ html()->form()->close() }}
</div>
@endsection

resources/views/internal/hotel/edit.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">

{{ html()->modelForm($hotel, 'PATCH', route('hotel.update', $hotel->id))->class('form-horizontal')->acceptsFiles()->open() }}
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Edit Hotel Detail</h6>
    </div>
    <div class="card-body">
        <div class="row mt-4 mb-4">
          <div class="col">
            <div class="form-group row">
              {{ html()->label('Name')->class('col-md-2 form-control-label')->for('name') }}
                <div class="col-md-10">
                    {{ html()->text('name')
                        ->class('form-control')
                        ->placeholder('name')
                        ->attribute('maxlength', 191)
                        ->value($hotel->name)
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            @role('admin')
            <div class="form-group row">
              {{ html()->label('Manager')->class('col-md-2 form-control-label')->for('manager') }}
                <div class="col-md-10">
                    {{ html()->select('manager_id', $managers->pluck('name','id'))
                        ->class('form-control')
                        ->value($hotel->manager_id)
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            @endrole
            <div class="form-group row">
              {{ html()->label('Address')->class('col-md-2 form-control-label')->for('address') }}
                  <div class="col-md-10">
                      {{ html()->text('address')
                          ->class('form-control')
                          ->placeholder('email')
                          ->attribute('maxlength', 191)
                          ->value($hotel->address)
                          ->required() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Phone')->class('col-md-2 form-control-label')->for('phone') }}

                  <div class="col-md-10">
                      {{ html()->text('phone')
                          ->class('form-control')
                          ->placeholder('phone')
                          ->attribute('maxlength', 191)
                          ->value($hotel->phone)
                          ->required() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('About')->class('col-md-2 form-control-label')->for('about') }}

                  <div class="col-md-10">
                      {{ html()->textarea('about')
                          ->class('form-control')
                          ->placeholder('about')
                          ->attribute('maxlength', 191)
                          ->value($hotel->about)
                          ->required() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="row">

            </div>
            <div class="form-group row">
                {{ html()->label('Photo')->class('col-md-2 form-control-label')->for('photo') }}

                    <div class="col-md-10">
                        <img class="img-profile rounded-circle mb-2" style="object-fit: cover;border-radius: 50%;
                    height: 200px;
                    width: 200px;" src="{{ $hotel->image_url ? Storage::disk('s3')->url($hotel->image_url) : Storage::disk('s3')->url('images/profiles/default.png') }}">
                        {{ html()->file('photo')
                            ->class('form-control') }}
                    </div><!--col-->
              </div><!--form-group-->

          </div>
        </div>

    </div>
    <div class="card-footer">
      <div class="row">
          <div class="col">
              <a href="{{ route('hotel.index') }}" class="btn btn-danger btn-sm">Cancel</a>
          </div><!--col-->

          <div class="col text-right">
            <button type="submit" class="btn btn-sm btn-success"><i class="fa fa-save"></i> Update</button>
              {{-- {{ form_submit('Update') }} --}}
          </div><!--row-->
      </div><!--row-->
    </div><!--card-footer-->
  </div>
  {{ html()->form()->close() }}
</div>
@endsection

resources/views/internal/hotel/index.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">

  <!-- Page Heading -->
  <h1 class="h3 mb-2 text-gray-800">Hotel List</h1>
  <p class="mb-4">Admin can list all internal user and member list.</p>

  <!-- DataTales Example -->
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Hotel List
      <a href="{{ route('hotel.create') }}" type="button" class="btn btn-sm btn-primary float-right"><i class="fa fa-plus"></i> Add Hotel</a></h6>

    </div>
    <div class="card-body">
      <div class="table-responsive">
        <table class="table table-sm">
          <thead class="thead">
            <tr>
              <th class="text-center">#</th>
              <th class="text-center">Hotel Code</th>
              <th class="text-center">Hotel Name</th>
              <th class="text-center" >Total Room</th>
              <th class="text-center">Manager</th>
              <th class="text-center">Hotel Address</th>
              <th class="text-center">Phone</th>
              <th class="text-center">Last Update</th>
              <th ></th>


            </tr>
          </thead>
          <tbody>
            @foreach ($hotels as $key => $hotel)
              <tr>
                <td class="text-center">{{ $key+1 }}</td>
                <td>{{ $hotel->code }}</td>
                <td>{{ $hotel->name }}</td>
                <td class="text-center">{{ $hotel->rooms()->count() }}</td>
                <td>{{ $hotel->manager->name }}</td>
                <td>{{ $hotel->address }}</td>
                <td>{{ $hotel->phone }}</td>
                <td>{{ $hotel->updated_at->diffForHumans() }}</td>
                <td >
                  <div class="btn-group" role="group" aria-label="User Actions">
                    <a href="{{ route('hotel.show', $hotel->id ) }}" data-toggle="tooltip" data-placement="top" title="" class="btn btn-info" data-original-title="View">
                        <i class="fas fa-eye"></i>
                    </a>
                    <a href="{{ route('hotel.edit', $hotel->id ) }}" data-toggle="tooltip" data-placement="top" title="" class="btn btn-primary" data-original-title="Edit">
                        <i class="fas fa-edit"></i>
                    </a>
                    <button type="button" id="btnDelete" data-id="{{$hotel->id}}" data-name="{{$hotel->name}}"  class="btn btn-danger btnDelete" >
                        <i class="fas fa-times"></i>
                    </button>
                </div>
                </td>
              </tr>
            @endforeach
          </tbody>
        </table>
      </div>
    </div>
  </div>

</div>
@endsection
@push('after-scripts')
<script>
$(document).ready(function() {
    $('.btnDelete').each(function(index) {
        $(this).on("click", function(){
            var hotel_id = $(this).data('id');
            var hotel = $(this).data('name');
            var content = document.createElement('div');
                content.innerHTML = 'Anda yakin ingin hapus hotel ini? <code>'+hotel+'</code>';

            Swal.fire({
                // position: 'bottom-end',
                icon: 'error',
                title: 'Delete a Hotel?',
                html: content,
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
                // toast: true,
                // timer: 3000,
                // showConfirmButton: false,

                // footer: '<a href>Why do I have this issue?</a>'
            }).then((result) => {
                if (result.value) {

                    $.ajax({
                        type: "DELETE",
                        url: "hotel/"+hotel_id,

                        headers: {
                            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                        },
                        cache: false,
                        success: function(response) {
                            Swal.fire(
                            'Deleted!',
                            'Your hotel has been deleted.',
                            'success'
                            ).then(function() {
                                window.location.reload(1);
                            });

                        },
                        error: function (response) {
                            console.log(response.responseJSON.message);
                            Swal.fire(
                            'Error!',
                            response.responseJSON.message,
                            'error'
                            );
                        }
                    })

                }
                })
            });
        });
});
</script>
@endpush

resources/views/internal/hotel/view.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">

  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Hotel Detail</h6>
    </div>
    <div class="card-body">
        <div class="row mt-4 mb-4">
          <div class="col">
            <div class="form-group row">
              {{ html()->label('Name')->class('col-md-2 form-control-label')->for('name') }}
                <div class="col-md-10">
                    {{ html()->text('name')
                        ->class('form-control')
                        ->placeholder('name')
                        ->attribute('maxlength', 191)
                        ->value($hotel->name)
                        ->readonly() }}
                </div><!--col-->
            </div><!--form-group-->
            
            <div class="form-group row">
              {{ html()->label('Address')->class('col-md-2 form-control-label')->for('address') }}
                  <div class="col-md-10">
                      {{ html()->text('address')
                          ->class('form-control')
                          ->placeholder('address')
                          ->attribute('maxlength', 191)
                          ->value($hotel->address)
                         }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Phone')->class('col-md-2 form-control-label')->for('phone') }}

                  <div class="col-md-10">
                      {{ html()->text('phone')
                          ->class('form-control')
                          ->placeholder('phone')
                          ->attribute('maxlength', 191)
                          ->value($hotel->phone)
                          ->readonly() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('About')->class('col-md-2 form-control-label')->for('about') }}

                  <div class="col-md-10">
                      {{ html()->textarea('about')
                          ->class('form-control')
                          ->placeholder('about')
                          ->attribute('maxlength', 191)
                          ->value($hotel->about)
                          }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="row">

            </div>
            <div class="form-group row">
                {{ html()->label('Photo')->class('col-md-2 form-control-label')->for('photo') }}

                    <div class="col-md-10">
                        <img class="img-profile rounded-circle mb-2" style="object-fit: cover;border-radius: 50%;
                    height: 200px;
                    width: 200px;" src="{{ $hotel->image_url ? Storage::disk('s3')->url($hotel->image_url) : Storage::disk('s3')->url('images/profiles/default.png') }}">
                        {{-- {{ html()->file('photo')
                            ->class('form-control') }} --}}
                    </div><!--col-->
              </div><!--form-group-->

          </div>
        </div>

    </div>
    
  </div>
</div>
@endsection